import { pgTable, integer, varchar, text, numeric, timestamp, uuid, unique, real, index, doublePrecision } from "drizzle-orm/pg-core"
import { sql } from "drizzle-orm"



export const products = pgTable("products", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "products_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	name: varchar({ length: 255 }).notNull(),
	description: text().notNull(),
	price: numeric().notNull(),
	resellerId: integer("reseller_id").notNull(),
	categoryId: integer("category_id").notNull(),
	stockQty: integer("stock_qty").default(0),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
});

export const categories = pgTable("categories", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "categories_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	name: varchar({ length: 100 }).notNull(),
	parentCategoryId: integer("parent_category_id"),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	uuid: uuid().defaultRandom(),
});

export const productFeeds = pgTable("product_feeds", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "productfeeds_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	resellerId: integer("reseller_id").notNull(),
	feedUrl: varchar("feed_url", { length: 255 }).notNull(),
	lastUpdate: timestamp("last_update", { mode: 'string' }),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	uuid: uuid().defaultRandom(),
}, (table) => {
	return {
		productFeedsUuidUnique: unique("product_feeds_uuid_unique").on(table.uuid),
	}
});

export const brands = pgTable("brands", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "brands_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	name: varchar({ length: 100 }).notNull(),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	uuid: uuid().defaultRandom(),
}, (table) => {
	return {
		brandsUuidUnique: unique("brands_uuid_unique").on(table.uuid),
	}
});

export const manufacturer = pgTable("manufacturer", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "manufacturer_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	name: varchar({ length: 100 }).notNull(),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	uuid: uuid().defaultRandom(),
}, (table) => {
	return {
		manufacturerUuidUnique: unique("manufacturer_uuid_unique").on(table.uuid),
	}
});

export const psa = pgTable("psa", {
	sku: varchar("SKU", { length: 50 }),
	manufacturerId: varchar("MANUFACTURER_ID", { length: 50 }),
	brandName: varchar("BRAND_NAME", { length: 50 }),
	productName: varchar("PRODUCT_NAME", { length: 255 }),
	longDescription: text("LONG_DESCRIPTION"),
	shortDescription: varchar("SHORT_DESCRIPTION", { length: 50 }),
	department: varchar("DEPARTMENT", { length: 50 }),
	category: varchar("CATEGORY", { length: 50 }),
	subcategory: varchar("SUBCATEGORY", { length: 50 }),
	thumbUrl: varchar("THUMB_URL", { length: 50 }),
	imageUrl: varchar("IMAGE_URL", { length: 50 }),
	buyLink: varchar("BUY_LINK", { length: 128 }),
	keywords: varchar("KEYWORDS", { length: 50 }),
	reviews: varchar("REVIEWS", { length: 50 }),
	retailPrice: real("RETAIL_PRICE"),
	salePrice: real("SALE_PRICE"),
	brandPageLink: varchar("BRAND_PAGE_LINK", { length: 50 }),
	brandLogoImage: varchar("BRAND_LOGO_IMAGE", { length: 50 }),
	productPageViewTracking: varchar("PRODUCT_PAGE_VIEW_TRACKING", { length: 256 }),
	parentGroupId: varchar("PARENT_GROUP_ID", { length: 50 }),
	fineline: varchar("FINELINE", { length: 50 }),
	superfineline: varchar("SUPERFINELINE", { length: 200 }),
	modelnumber: varchar("MODELNUMBER", { length: 50 }),
	caliber: varchar("CALIBER", { length: 200 }),
	upc: varchar("UPC", { length: 100 }),
	mediumImageUrl: varchar("MEDIUM_IMAGE_URL", { length: 50 }),
	productContentWidget: varchar("PRODUCT_CONTENT_WIDGET", { length: 256 }),
	googleCategorization: varchar("GOOGLE_CATEGORIZATION", { length: 50 }),
	itemBasedCommission: varchar("ITEM_BASED_COMMISSION", { length: 50 }),
});

export const states = pgTable("states", {
	id: integer().primaryKey().generatedByDefaultAsIdentity({ name: "states_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	state: varchar({ length: 50 }),
	abbreviation: varchar({ length: 50 }),
});

export const componentType = pgTable("component_type", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "component_type_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	name: varchar({ length: 100 }).notNull(),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	uuid: uuid().defaultRandom(),
}, (table) => {
	return {
		componentTypeUuidUnique: unique("component_type_uuid_unique").on(table.uuid),
	}
});

export const compartment = pgTable("compartment", {
	id: uuid().defaultRandom().primaryKey().notNull(),
	name: varchar({ length: 100 }).notNull(),
	description: varchar({ length: 300 }),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
});

export const builds = pgTable("builds", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "build_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	accountId: integer("account_id").notNull(),
	name: varchar({ length: 255 }).notNull(),
	description: text(),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	uuid: uuid().defaultRandom(),
}, (table) => {
	return {
		idIdx: index("builds_id_idx").using("btree", table.id.asc().nullsLast().op("int4_ops")),
		uuidIdx: index("builds_uuid_idx").using("btree", table.uuid.asc().nullsLast().op("uuid_ops")),
		buildsUuidUnique: unique("builds_uuid_unique").on(table.uuid),
	}
});

export const balAccounts = pgTable("bal_accounts", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "accountsid_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	firstName: varchar("first_name", { length: 40 }),
	lastName: varchar("last_name", { length: 40 }),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	email: varchar({ length: 100 }),
	username: varchar({ length: 50 }).notNull(),
	passwordHash: varchar("password_hash", { length: 255 }).notNull(),
	uuid: uuid().defaultRandom(),
}, (table) => {
	return {
		balAccountsUsernameUnique: unique("bal_accounts_username_unique").on(table.username),
		balAccountsPasswordHashUnique: unique("bal_accounts_password_hash_unique").on(table.passwordHash),
		balAccountsUuidUnique: unique("bal_accounts_uuid_unique").on(table.uuid),
	}
});

export const lipseycatalog = pgTable("lipseycatalog", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "lipseycatalog_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	itemno: varchar({ length: 20 }).notNull(),
	description1: text(),
	description2: text(),
	upc: varchar({ length: 20 }),
	manufacturermodelno: varchar({ length: 30 }),
	msrp: doublePrecision(),
	model: text(),
	calibergauge: text(),
	manufacturer: text(),
	type: text(),
	action: text(),
	barrellength: text(),
	capacity: text(),
	finish: text(),
	overalllength: text(),
	receiver: text(),
	safety: text(),
	sights: text(),
	stockframegrips: text(),
	magazine: text(),
	weight: text(),
	imagename: text(),
	chamber: text(),
	drilledandtapped: text(),
	rateoftwist: text(),
	itemtype: text(),
	additionalfeature1: text(),
	additionalfeature2: text(),
	additionalfeature3: text(),
	shippingweight: text(),
	boundbookmanufacturer: text(),
	boundbookmodel: text(),
	boundbooktype: text(),
	nfathreadpattern: text(),
	nfaattachmentmethod: text(),
	nfabaffletype: text(),
	silencercanbedisassembled: text(),
	silencerconstructionmaterial: text(),
	nfadbreduction: text(),
	silenceroutsidediameter: text(),
	nfaform3Caliber: text(),
	opticmagnification: text(),
	maintubesize: text(),
	adjustableobjective: text(),
	objectivesize: text(),
	opticadjustments: text(),
	illuminatedreticle: text(),
	reticle: text(),
	exclusive: text(),
	quantity: varchar({ length: 10 }).default(sql`NULL`),
	allocated: text(),
	onsale: text(),
	price: doublePrecision(),
	currentprice: doublePrecision(),
	retailmap: doublePrecision(),
	fflrequired: text(),
	sotrequired: text(),
	exclusivetype: text(),
	scopecoverincluded: text(),
	special: text(),
	sightstype: text(),
	case: text(),
	choke: text(),
	dbreduction: text(),
	family: text(),
	finishtype: text(),
	frame: text(),
	griptype: varchar({ length: 30 }),
	handgunslidematerial: text(),
	countryoforigin: varchar({ length: 4 }),
	itemlength: text(),
	itemwidth: text(),
	itemheight: text(),
	packagelength: doublePrecision(),
	packagewidth: doublePrecision(),
	packageheight: doublePrecision(),
	itemgroup: varchar({ length: 40 }),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
});

export const buildsComponents = pgTable("builds_components", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "build_components_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	buildId: integer("build_id").notNull(),
	productId: integer("product_id").notNull(),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	uuid: uuid().defaultRandom(),
}, (table) => {
	return {
		buildsComponentsUuidUnique: unique("builds_components_uuid_unique").on(table.uuid),
	}
});

export const balResellers = pgTable("bal_resellers", {
	id: integer().primaryKey().generatedAlwaysAsIdentity({ name: "resellers_id_seq", startWith: 1, increment: 1, minValue: 1, maxValue: 2147483647, cache: 1 }),
	name: varchar({ length: 100 }).notNull(),
	websiteUrl: varchar("website_url", { length: 255 }),
	contactEmail: varchar("contact_email", { length: 100 }),
	updatedAt: timestamp("updated_at", { mode: 'string' }).defaultNow().notNull(),
	createdAt: timestamp("created_at", { mode: 'string' }).defaultNow().notNull(),
	deletedAt: timestamp("deleted_at", { mode: 'string' }),
	uuid: uuid().defaultRandom(),
}, (table) => {
	return {
		balResellersUuidUnique: unique("bal_resellers_uuid_unique").on(table.uuid),
	}
});
